/****************************************************************************\
*                                                                            *
*  FGIW1.CPP                                                                 *
*  FGIW1U.CPP                                                                *
*                                                                            *
*  Demonstrate the basic Fastgraph/Image for Windows operations of opening   *
*  an FGI file and displaying a PCX image from that FGI file.                *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "FGIW1U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(320,200);
   fg_vbopen(hvb);
   fg_vbcolors();

   hfgi = fgi_open("EXAMPLE.FGI");
   if (hfgi == 0)
   {
      Application->MessageBox("Unable to open FGI file.","Error",MB_ICONSTOP|MB_OK);
      Application->Terminate();
      return;
   }
   fgi_display("CLOUDS.PCX",2,hfgi);
   fgi_close(hfgi);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
